package Onis::Plugins::Topics;

use strict;
use warnings;

use Onis::Config qw/get_config/;
use Onis::Html qw/html_escape get_filehandle/;
use Onis::Language qw/translate/;
use Onis::Data::Core qw#register_plugin#;
use Onis::Data::Persistent qw#init#;

our $DATA = init ('$DATA', 'array');
our $NickData;

$NickData = register_plugin ('TOPIC', \&add);
$NickData = register_plugin ('OUTPUT', \&output);

our $MAX = 10;
if (get_config ('plugin_max'))
{
	my $tmp = get_config ('plugin_max');
	$tmp =~ s/\D//g;

	$MAX = $tmp if ($tmp);
}

my $VERSION = '$Id: Topics.pm,v 1.4 2004/04/30 06:56:13 octo Exp $';
print STDERR $/, __FILE__, ": $VERSION" if ($::DEBUG);

return (1);

sub add
{
	my $data = shift;
	my $topic = $data->{'text'};
	my $nick = $data->{'nick'};

	push (@$DATA, [$topic, $nick]);
	
	while (scalar (@$DATA) > $MAX) { shift (@$DATA); }

	$NickData->{'bynick'}{$nick}{'topics'}++;

	return (1);
}

sub output
{
	return (undef) unless (@$DATA);
	my $fh = get_filehandle ();
	
	my $topic = translate ('Topic');
	my $setby = translate ('Set by');

	print $fh <<EOF;
<table class="plugin">
  <tr>
    <td class="invis">&nbsp;</td>
    <th>$topic</th>
    <th>$setby</th>
  </tr>
EOF

	my $i = 0;
	for (reverse (@$DATA))
	{
		$i++;
		my ($topic, $nick) = @$_;

		$topic = html_escape ($topic);
		
		print $fh "  <tr>\n",
		qq#    <td class="numeration">$i</td>\n#,
		qq#    <td>$topic</td>\n#,
		qq#    <td class="nick">$nick</td>\n#,
		qq#  </tr>\n#;
	}

	print $fh "</table>\n\n";
}
